#!/bin/sh

# Copyright (C) 2010, 2012 Free Software Foundation, Inc.
#
# Author: Nikos Mavrogiannopoulos
#
# This file is part of GnuTLS.
#
# GnuTLS is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# GnuTLS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GnuTLS; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

set -e

srcdir="${srcdir:-.}"
CERTTOOL="${CERTTOOL:-../../src/certtool$EXEEXT}"

unset RETCODE || true

fail() {
   echo "Failure: $1" >&2
   RETCODE=${RETCODE:-${2:-1}}
}

echo "Checking OpenPGP certificate self verification"

($CERTTOOL --inraw --pgp-certificate-info --infile $srcdir/selfsigs/alice.pub \
    | grep "^Self Signature verification: ok" > /dev/null) || \
    fail "Self sig Verification should have succeeded!"

($CERTTOOL --inraw --pgp-certificate-info --infile $srcdir/selfsigs/alice-mallory-badsig18.pub \
    | grep "^Self Signature verification: failed" > /dev/null) || \
    fail "Self sig Verification should have failed!"

($CERTTOOL --inraw --pgp-certificate-info --infile $srcdir/selfsigs/alice-mallory-irrelevantsig.pub \
    | grep "^Self Signature verification: failed" >/dev/null) || \
    fail "Self sig Verification should have failed!"

($CERTTOOL --inraw --pgp-certificate-info --infile $srcdir/selfsigs/alice-mallory-nosig18.pub \
    | grep "^Self Signature verification: failed" >/dev/null) || \
    fail "Self sig Verification should have failed!"

exit ${RETCODE:-0}
